HDU-1015,Safecracker

简介: HDU-1015,Safecracker

Problem Description:


=== Op tech briefing, 2002/11/02 06:42 CST ===

"The item is locked in a Klein safe behind a painting in the second-floor library. Klein safes are extremely rare; most of them, along with Klein and his factory, were destroyed in World War II. Fortunately old Brumbaugh from research knew Klein's secrets and wrote them down before he died. A Klein safe has two distinguishing features: a combination lock that uses letters instead of numbers, and an engraved quotation on the door. A Klein quotation always contains between five and twelve distinct uppercase letters, usually at the beginning of sentences, and mentions one or more numbers. Five of the uppercase letters form the combination that opens the safe. By combining the digits from all the numbers in the appropriate way you get a numeric target. (The details of constructing the target number are classified.) To find the combination you must select five letters v, w, x, y, and z that satisfy the following equation, where each letter is replaced by its ordinal position in the alphabet (A=1, B=2, ..., Z=26). The combination is then vwxyz. If there is more than one solution then the combination is the one that is lexicographically greatest, i.e., the one that would appear last in a dictionary."


v - w^2 + x^3 - y^4 + z^5 = target


"For example, given target 1 and letter set ABCDEFGHIJKL, one possible solution is FIECB, since 6 - 9^2 + 5^3 - 3^4 + 2^5 = 1. There are actually several solutions in this case, and the combination turns out to be LKEBA. Klein thought it was safe to encode the combination within the engraving, because it could take months of effort to try all the possibilities even if you knew the secret. But of course computers didn't exist then."


=== Op tech directive, computer division, 2002/11/02 12:30 CST ===


"Develop a program to find Klein combinations in preparation for field deployment. Use standard test methodology as per departmental regulations. Input consists of one or more lines containing a positive integer target less than twelve million, a space, then at least five and at most twelve distinct uppercase letters. The last line will contain a target of zero and the letters END; this signals the end of the input. For each line output the Klein combination, break ties with lexicographic order, or 'no solution' if there is no correct combination. Use the exact format shown below."


Sample Input:


1 ABCDEFGHIJKL


11700519 ZAYEXIWOVU


3072997 SOUGHT


1234567 THEQUICKFROG


0 END


Sample Output:


LKEBA


YOXUZ


GHOST


no solution


解题思路:


先将字符串按照字典序去排序,然后根据题意:v-w^2+x^3-y^4+z^5=目标,五个for循环去寻找,找到满足题意的输出即可,如果找不到则输出no solution。


程序代码:


#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
using namespace std;
char str[25];
bool cmp(char a,char b)
{
    return a>b;
}
int main()
{
    int a,b,c,d,e,ta,tb,tc,td,te,target,flag;
    while(scanf("%d %s",&target,str))
    {
        if(target==0)
            break;
        int len=strlen(str);
        flag=0;
        sort(str,str+len,cmp);
        for(a=0;a<len;a++)
        {
            for(b=0;b<len;b++)
            {
                if(a==b)
                    continue;
                for(c=0;c<len;c++)
                {
                    if(a==c||b==c)
                        continue;
                    for(d=0;d<len;d++)
                    {
                        if(a==d||b==d||c==d)
                            continue;
                        for(e=0;e<len;e++)
                        {
                            if(a==e||b==e||c==e||d==e)
                                continue;
                            ta=str[a]-'A'+1;
                            tb=str[b]-'A'+1;
                            tc=str[c]-'A'+1;
                            td=str[d]-'A'+1;
                            te=str[e]-'A'+1;
                            if(ta-tb*tb+tc*tc*tc-td*td*td*td+
                                te*te*te*te*te==target)
                            {
                                flag=1;
                                printf("%c%c%c%c%c\n",str[a],
                                    str[b],str[c],str[d],str[e]);
                                break;    
                            }
                        }
                        if(flag)
                            break;
                    }
                    if(flag)
                        break;
                }
                if(flag)
                    break;
            }
            if(flag)
                break;
        }
        if(flag==0)
            printf("no solution\n");
    }
    return 0;
}


相关文章
|
6月前
|
Java
HDU-1896-Stones
HDU-1896-Stones
28 0
|
6月前
|
Java
hdu-2546-饭卡
hdu-2546-饭卡
29 0
|
6月前
|
机器学习/深度学习 存储 人工智能
HDU - 5912——Fraction
HDU - 5912——Fraction
|
Java
hdu 1257 最少拦截系统
hdu 1257 最少拦截系统
48 0
|
Java 人工智能
|
机器学习/深度学习
hdu 2604 Queuing
点击打开hdu 2604 思路: 递推+矩阵快速幂 分析; 1 根据题目的意思,我们可以求出F[0] = 0 , F[1] = 2 , F[2] = 4 , F[3] = 6 , F[4] = 9 , F[5] = 15 2 那么根据上面...
799 0
hdu 1892 See you~
点击打开hdu 1892 思路: 二维树状数组 分析: 1 题目给定4种操作:  S x1 y1 x2 y2 询问以(x1 , y1) - (x2 , y2)为对角线的矩形的面积,但是这个对角线不一定是正对角线。
1015 0
|
人工智能
HDU1106
为了给学弟学妹讲课,我又水了一题…… 1: import java.util.*; 2: import java.io.*; 3: 4: public class HDU1106 5: { 6: public static void main...
878 0
|
固态存储
hdu 2333 Assemble
点击打开链接hdu 2333 思路:二分答案 分析: 1 首先我们遇到这类无从下手的题目的时候,我们首先应该考虑的就是利用二分答案,其它我们无从下手。
863 0